#
# This file MUST be in SHIFT_JIS
#
# msbtck.pl:
# Detect troublesome characters in Japanese (Shift_JIS) for MaestroSBT
# 2004-02-17

$filename = $ARGV[0];

unless($filename) {
	print( "Usage: perl msbtck.pl ssa_in_sjis\n" );
	exit;
}

@DAMEMOJI = (
	'{','{','{','{','{','{','{','{',
	'{','{','{','{','{','{','{','{',
	'{','{','{','{','{','{','{','{',
	'{','{','{','{','{','{','{','{',
	'{','','','{','{','{','{','{'
);

$LEN = scalar @DAMEMOJI;

open IN, "<$filename" or die("Error: Couldn't open '$filename': $!");
open OUT, ">$filename.dame" or die("Error: Couldn't open '$filename.dame': $!");

print OUT "--- msbtck.pl for $filename ---\n";


$line = 0;
$cnt = 0;
while(<IN>) {
	$line++;
	chomp;

	for( $i = 0; $i < $LEN; $i++ ) {
		if( /$DAMEMOJI[$i]/ ) {
			$cnt++;
			$warning = "LINE $line: Damemoji'" . $DAMEMOJI[ $i ] . "' in $_\n";
			print $warning;
			print OUT $warning;
		}
	}
}

print "--- msbtck.pl for $filename ---\n";
print "$line line(s): $cnt warning(s)\n";

print OUT  "$line line(s): $cnt warning(s)\n";

close IN, close OUT;
